%{
#include <string.h>
%}
 
EOL	\n
BLANK	[\t ]
LETTERA	[A-Za-z_]
DIGIT   [0-9]
ID	{LETTERA}({LETTERA}|{DIGIT})*

%%
const	{return CONST;}
"+"	{yylval="ADD";return addop;}
"-"   	{yylval="SUB";return addop;}
"*"	{yylval="MUL";return mulop;}
"/"   	{yylval="DIV";return mulop;}
"="       {return relop;}
{ID}      {yylval=strdup(yytext);return id;}
{DIGIT}+  {yylval=strdup(yytext);return num;}
{BLANK}+  {;}
.	  {return yytext[0];}
{EOL}  {;}
%%

int yywrap()
{
return 1;
}


