#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#define MAX_ID_LEN		20
#define MAX_VALUE_LEN	20
#define MAX_SYM			20
#define MAX_TEMP		20

extern FILE *file_errori;

typedef struct s_l
  {
    char* s_id;//[MAX_ID_LEN];
    char* s_val;//[MAX_VALUE_LEN];
  }
sym_elem;

typedef struct symbol_tbl
  {
    sym_elem symbol[MAX_SYM];
    int next_free_sym;
  }
 *p_symbol_tbl;

/**************************************************************/
void 
update_temp (p_symbol_tbl S, char *a, char *b)
/* riutilizza i temporanei usati */
{
  if (isdigit (a[0]))
{
  free(S->symbol[S->next_free_sym-1].s_id);
    S->next_free_sym--;
}

  if (isdigit (b[0]))
{
free(S->symbol[S->next_free_sym-1].s_id);
S->next_free_sym--;
}
}

/**************************************************************/
char *
newtemp (p_symbol_tbl S, char *s_val)
{
  char *t;
  t=malloc(MAX_TEMP);
  sprintf (t, "%d", S->next_free_sym);
  insert (S, t, s_val);
  return S->symbol[S->next_free_sym - 1].s_id;

}

/**************************************************************/

int 
insert (p_symbol_tbl S, char *name, char *value)
{
  int i = find (S, name);
  if (i >= 0)
    {
      fprintf(file_errori,"\nWarning: ridefinizione della costante %s\n", name);
      free(S->symbol[i].s_val);
	S->symbol[i].s_val=value;	
      return i;
    }
	S->symbol[S->next_free_sym].s_val=value;	
	S->symbol[S->next_free_sym].s_id=name;	
  return S->next_free_sym++;
}

/**************************************************************/

int 
find (p_symbol_tbl S, char *c)
{
  int i = (S->next_free_sym) - 1;
  while (i >= 0)
    {
      if (!strcmp (S->symbol[i].s_id, c))
	break;
      i--;
    }
return i;

}
